//--------------------------------------------------------------
//
//  TAPI.PRG
//
//  This file contains Windows API function declarations
//  for calls to the Win32 Telephony API from Visual dBASE.
//  The type declarations and constants for the Telephony
//  API are stored in the file TAPI.H
//
//  Visual dBASE 7.0 Samples Group
//
//  $Revision:   1.1  $
//
//  Copyright (c) 1997, Borland International, Inc. 
//  All rights reserved.
//
//--------------------------------------------------------------
//
// The  Telephony  API  is jointly copyrighted by Intel and Microsoft.  You are
// granted  a royalty free worldwide, unlimited license to make copies, and use
// the   API/SPI  for  making  applications/drivers  that  interface  with  the
// specification provided that this paragraph and the Intel/Microsoft copyright
// statement is maintained as is in the text and source code files.
//
// Copyright 1995 Microsoft, all rights reserved.
// Portions copyright 1992, 1993 Intel/Microsoft, all rights reserved.

#include <TAPI.H>

// Simple Telephony prototypes

extern LONG  tapiRequestMakeCall(LPCSTR, LPCSTR, LPCSTR, LPCSTR) tapi32.dll
extern LONG  tapiRequestMediaCall(HWND, WPARAM, LPCSTR, LPCSTR, DWORD, ;
             DWORD, LPCSTR, LPCSTR, LPCSTR, LPCSTR) tapi32.dll
extern LONG  tapiRequestDrop(HWND, WPARAM) tapi32.dll
extern LONG  lineRegisterRequestRecipient(HLINEAPP, DWORD, DWORD, ;
             DWORD) tapi32.dll
extern LONG  tapiGetLocationInfo(LPSTR, LPSTR) tapi32.dll

// Tapi Address Translation procedures

extern LONG  lineSetCurrentLocation(HLINEAPP, DWORD) tapi32.dll
extern LONG  lineSetTollList(HLINEAPP, DWORD, LPCSTR, DWORD) tapi32.dll
extern LONG  lineTranslateAddress(HLINEAPP, DWORD, DWORD, LPCSTR, DWORD, ;
             DWORD, LPLINETRANSLATEOUTPUT) tapi32.dll
extern LONG  lineGetTranslateCaps(HLINEAPP, DWORD, ;
             LPLINETRANSLATECAPS) tapi32.dll

// Tapi function prototypes

extern LONG  lineAccept(HCALL, LPCSTR, DWORD) tapi32.dll
extern LONG  lineAddToConference(HCALL, HCALL) tapi32.dll
extern LONG  lineAnswer(HCALL, LPCSTR, DWORD) tapi32.dll
extern LONG  lineBlindTransfer(HCALL, LPCSTR, DWORD) tapi32.dll
extern LONG  lineClose(HLINE) tapi32.dll
extern LONG  lineCompleteCall(HCALL, LPDWORD, DWORD, DWORD) tapi32.dll
extern LONG  lineCompleteTransfer(HCALL, HCALL, LPHCALL, DWORD) tapi32.dll
extern LONG  lineConfigDialog(DWORD, HWND, LPCSTR) tapi32.dll
extern LONG  lineConfigDialogEdit(DWORD, HWND, LPCSTR, LPVOID, DWORD, ;
             LPVARSTRING) tapi32.dll
extern LONG  lineDeallocateCall(HCALL) tapi32.dll
extern LONG  lineDevSpecific(HLINE, DWORD, HCALL, LPVOID, DWORD) tapi32.dll
extern LONG  lineDevSpecificFeature(HLINE, DWORD, LPVOID, DWORD) tapi32.dll
extern LONG  lineDial(HCALL, LPCSTR, DWORD) tapi32.dll
extern LONG  lineDrop(HCALL, LPCSTR, DWORD) tapi32.dll
extern LONG  lineForward(HLINE, DWORD, DWORD, LPLINEFORWARDLIST, ;
             DWORD, LPHCALL, LPLINECALLPARAMS) tapi32.dll
extern LONG  lineGatherDigits(HCALL, DWORD, LPSTR, DWORD, LPCSTR, ;
             DWORD, DWORD) tapi32.dll
extern LONG  lineGenerateDigits(HCALL, DWORD, LPCSTR, DWORD) tapi32.dll
extern LONG  lineGenerateTone(HCALL, DWORD, DWORD, DWORD, ;
             LPLINEGENERATETONE) tapi32.dll
extern LONG  lineGetAddressCaps(HLINEAPP, DWORD, DWORD, DWORD, DWORD, ;
             LPLINEADDRESSCAPS) tapi32.dll
extern LONG  lineGetAddressID(HLINE, LPDWORD, DWORD, LPCSTR, DWORD) tapi32.dll
extern LONG  lineGetAddressStatus(HLINE, DWORD, LPLINEADDRESSSTATUS) tapi32.dll
extern LONG  lineGetCallInfo(HCALL, LPLINECALLINFO) tapi32.dll
extern LONG  lineGetCallStatus(HCALL, LPLINECALLSTATUS) tapi32.dll
extern LONG  lineGetConfRelatedCalls(HCALL, LPLINECALLLIST) tapi32.dll
extern LONG  lineGetDevCaps(HLINEAPP, DWORD, DWORD, DWORD, ;
             LPLINEDEVCAPS) tapi32.dll
extern LONG  lineGetDevConfig(DWORD, LPVARSTRING, LPCSTR) tapi32.dll
extern LONG  lineGetNewCalls(HLINE, DWORD, DWORD, LPLINECALLLIST) tapi32.dll
extern LONG  lineGetIcon(DWORD, LPCSTR, LPHICON) tapi32.dll
extern LONG  lineGetID(HLINE, DWORD, HCALL, DWORD, LPVARSTRING, ;
             LPCSTR) tapi32.dll
extern LONG  lineGetLineDevStatus(HLINE, LPLINEDEVSTATUS) tapi32.dll
extern LONG  lineGetNumRings(HLINE, DWORD, LPDWORD) tapi32.dll
extern LONG  lineGetRequest(HLINEAPP, DWORD, LPVOID) tapi32.dll
extern LONG  lineGetStatusMessages(HLINE, LPDWORD, LPDWORD) tapi32.dll
extern LONG  lineHandoff(HCALL, LPCSTR, DWORD) tapi32.dll
extern LONG  lineHold(HCALL) tapi32.dll
extern LONG  lineInitialize(LPHLINEAPP, HINSTANCE, LINECALLBACK, ;
             LPCSTR, LPDWORD) tapi32.dll
extern LONG  lineMakeCall(HLINE, LPHCALL, LPCSTR, DWORD, ;
             LPLINECALLPARAMS) tapi32.dll
extern LONG  lineMonitorDigits(HCALL, DWORD) tapi32.dll
extern LONG  lineMonitorMedia(HCALL, DWORD) tapi32.dll
extern LONG  lineMonitorTones(HCALL, LPLINEMONITORTONE, DWORD) tapi32.dll
extern LONG  lineNegotiateAPIVersion(HLINEAPP, DWORD, DWORD, DWORD, ;
             LPDWORD, LPLINEEXTENSIONID) tapi32.dll
extern LONG  lineNegotiateExtVersion(HLINEAPP, DWORD, DWORD, DWORD, ;
             DWORD, LPDWORD) tapi32.dll
extern LONG  lineOpen(HLINEAPP, DWORD, LPHLINE, DWORD, DWORD, DWORD, ;
             DWORD, DWORD, LPLINECALLPARAMS) tapi32.dll
extern LONG  linePark(HCALL, DWORD, LPCSTR, LPVARSTRING) tapi32.dll
extern LONG  linePickup(HLINE, DWORD, LPHCALL, LPCSTR, LPCSTR) tapi32.dll
extern LONG  linePrepareAddToConference(HCALL, LPHCALL, ;
             LPLINECALLPARAMS) tapi32.dll
extern LONG  lineRedirect(HCALL, LPCSTR, DWORD) tapi32.dll
extern LONG  lineRemoveFromConference(HCALL) tapi32.dll
extern LONG  lineSecureCall(HCALL) tapi32.dll
extern LONG  lineSendUserUserInfo(HCALL, LPCSTR, DWORD) tapi32.dll
extern LONG  lineSetAppSpecific(HCALL, DWORD) tapi32.dll
extern LONG  lineSetCallParams(HCALL, DWORD, DWORD, DWORD, ;
             LPLINEDIALPARAMS) tapi32.dll
extern LONG  lineSetCallPrivilege(HCALL, DWORD) tapi32.dll
extern LONG  lineSetDevConfig(DWORD, LPVOID, DWORD, LPCSTR) tapi32.dll
extern LONG  lineSetMediaControl(HLINE, DWORD, HCALL, DWORD, ;
             LPLINEMEDIACONTROLDIGIT, DWORD, LPLINEMEDIACONTROLMEDIA, ;
             DWORD, LPLINEMEDIACONTROLTONE, DWORD, ;
             LPLINEMEDIACONTROLCALLSTATE, DWORD) tapi32.dll
extern LONG  lineSetMediaMode(HCALL, DWORD) tapi32.dll
extern LONG  lineSetNumRings(HLINE, DWORD, DWORD) tapi32.dll
extern LONG  lineSetStatusMessages(HLINE, DWORD, DWORD) tapi32.dll
extern LONG  lineSetTerminal(HLINE, DWORD, HCALL, DWORD, DWORD, ;
             DWORD, DWORD) tapi32.dll
extern LONG  lineSetupConference(HCALL, HLINE, LPHCALL, LPHCALL, ;
             DWORD, LPLINECALLPARAMS) tapi32.dll
extern LONG  lineSetupTransfer(HCALL, LPHCALL, LPLINECALLPARAMS) tapi32.dll
extern LONG  lineShutdown(HLINEAPP) tapi32.dll
extern LONG  lineSwapHold(HCALL, HCALL) tapi32.dll
extern LONG  lineUncompleteCall(HLINE, DWORD) tapi32.dll
extern LONG  lineUnhold(HCALL) tapi32.dll
extern LONG  lineUnpark(HLINE, DWORD, LPHCALL, LPCSTR) tapi32.dll
extern LONG  lineReleaseUserUserInfo(HCALL) tapi32.dll

extern LONG  phoneClose(HPHONE) tapi32.dll
extern LONG  phoneConfigDialog(DWORD, HWND, LPCSTR) tapi32.dll
extern LONG  phoneDevSpecific(HPHONE, LPVOID, DWORD) tapi32.dll
extern LONG  phoneGetButtonInfo(HPHONE, DWORD, LPPHONEBUTTONINFO) tapi32.dll
extern LONG  phoneGetData(HPHONE, DWORD, LPVOID, DWORD) tapi32.dll
extern LONG  phoneGetDevCaps(HPHONEAPP, DWORD, DWORD, DWORD, ;
             LPPHONECAPS) tapi32.dll
extern LONG  phoneGetDisplay(HPHONE, LPVARSTRING) tapi32.dll
extern LONG  phoneGetGain(HPHONE, DWORD, LPDWORD) tapi32.dll
extern LONG  phoneGetHookSwitch(HPHONE, LPDWORD) tapi32.dll
extern LONG  phoneGetIcon(DWORD, LPCSTR, LPHICON) tapi32.dll
extern LONG  phoneGetID(HPHONE, LPVARSTRING, LPCSTR) tapi32.dll
extern LONG  phoneGetLamp(HPHONE, DWORD, LPDWORD) tapi32.dll
extern LONG  phoneGetRing(HPHONE, LPDWORD, LPDWORD) tapi32.dll
extern LONG  phoneGetStatus(HPHONE, LPPHONESTATUS) tapi32.dll
extern LONG  phoneGetStatusMessages(HPHONE, LPDWORD, LPDWORD, ;
             LPDWORD) tapi32.dll
extern LONG  phoneGetVolume(HPHONE, DWORD, LPDWORD) tapi32.dll
extern LONG  phoneInitialize(LPHPHONEAPP, HINSTANCE, PHONECALLBACK, ;
             LPCSTR, LPDWORD) tapi32.dll
extern LONG  phoneNegotiateAPIVersion(HPHONEAPP, DWORD, DWORD, DWORD, ;
             LPDWORD, LPPHONEEXTENSIONID) tapi32.dll
extern LONG  phoneNegotiateExtVersion(HPHONEAPP, DWORD, DWORD, DWORD, ;
             DWORD, LPDWORD) tapi32.dll
extern LONG  phoneOpen(HPHONEAPP, DWORD, LPHPHONE, DWORD, DWORD, ;
             DWORD, DWORD) tapi32.dll
extern LONG  phoneSetButtonInfo(HPHONE, DWORD, LPPHONEBUTTONINFO) tapi32.dll
extern LONG  phoneSetData(HPHONE, DWORD, LPVOID, DWORD) tapi32.dll
extern LONG  phoneSetDisplay(HPHONE, DWORD, DWORD, LPCSTR, DWORD) tapi32.dll
extern LONG  phoneSetGain(HPHONE, DWORD, DWORD) tapi32.dll
extern LONG  phoneSetHookSwitch(HPHONE, DWORD, DWORD) tapi32.dll
extern LONG  phoneSetLamp(HPHONE, DWORD, DWORD) tapi32.dll
extern LONG  phoneSetRing(HPHONE, DWORD, DWORD) tapi32.dll
extern LONG  phoneSetStatusMessages(HPHONE, DWORD, DWORD, DWORD) tapi32.dll
extern LONG  phoneSetVolume(HPHONE, DWORD, DWORD) tapi32.dll
extern LONG  phoneShutdown(HPHONEAPP) tapi32.dll

extern LONG  lineTranslateDialog(HLINEAPP, DWORD, DWORD, HWND, ;
             LPCSTR) tapi32.dll
extern LONG  lineGetCountry(DWORD, DWORD, LPLINECOUNTRYLIST) tapi32.dll
extern LONG  lineGetAppPriority(LPCSTR, DWORD, LPLINEEXTENSIONID, DWORD, ;
             LPVARSTRING, LPDWORD) tapi32.dll
extern LONG  lineSetAppPriority(LPCSTR, DWORD, LPLINEEXTENSIONID, DWORD, ;
             LPCSTR, DWORD) tapi32.dll
extern LONG  lineAddProvider(LPCSTR, HWND, LPDWORD) tapi32.dll
extern LONG  lineConfigProvider(HWND, DWORD) tapi32.dll
extern LONG  lineRemoveProvider(DWORD, HWND) tapi32.dll
extern LONG  lineGetProviderList(DWORD, LPLINEPROVIDERLIST) tapi32.dll

