//--------------------------------------------------------------
//
//  WIN32API.H 
//
//  This header file contains Windows API type and 
//  constant declarations for calls to the Win32 API 
//  from Visual dBASE. Function prototypes are in 
//  WIN32API.PRG.
// 
//  Dependencies: WINNT.H
//                WINBASE.H
//                WINGDI.H
//                WINUSER.H
//                WINMISC.H
//                WINREG.H             
//                WIN32API.PRG
//
//  Visual dBASE Samples Group
//
//  $Revision:   1.3  $
//
//  Copyright (c) 1997, Borland International, Inc. 
//  All rights reserved.
//
//---------------------------------------------------------------

#ifndef WIN32API_H
   #define WIN32API_H

   #include <WINDEF.H>

   //
   //  SECTION INCLUSION.
   //
   //
   //  These can be used to include one or more header files or 
   //  sections of header files. 
   //
   //  Note: Do to compilation restrictions, not all header
   //  files can be included in a single source file.
   //
   //
   //  WIN32API_MESSAGES_H    -  Include messaging constants
   //                            in WINUSER.H
   //  WIN32API_MISC_H        -  Include the WINMISC.H file
   //  WIN32API_BASE_H        -  Include the WINBASE.H file
   //  WIN32API_GDI_H         -  Include the WINGDI.H file
   //  WIN32API_NT_H          -  Include the WINNT.H file
   //  WIN32API_REG_H         -  Include the WINREG.H file
   //  WIN32API_USER_H        -  Include the WINUSER.H file
   //
   //  


   #ifdef WIN32API_NT_H
      #include <WINNT.H>
   #else
      // WINNT.H and WINREG.H are mutually exclusive
      #ifdef WIN32API_REG_H
          #include <WINREG.H>
      #endif
   #endif


   #ifdef WIN32API_BASE_H
      #include <WINBASE.H>
   #endif

   #ifdef WIN32API_GDI_H
      #include <WINGDI.H>
   #endif
   
   #ifdef WIN32API_USER_H
      #include <WINUSER.H>
   #endif

   #ifndef WIN32API_MISC_H
      #include <WINMISC.H>
   #endif
   DO ( _dbwinhome + "\INCLUDE\WIN32API.PRG" )

#endif // WIN32API_H
