//--------------------------------------------------------------
//
//  WINSPOOL.PRG
//
//  This file contains Windows API function declarations
//  for calls to the Win32 print system from Visual dBASE.
//  The type declarations and constants are stored in 
//  the file WINSPOOL.H
//
//  Visual dBASE 7.0 Samples Group
//
//  $Revision:   1.1  $
//
//  Copyright (c) 1997, Borland International, Inc. 
//  All rights reserved.
//
//--------------------------------------------------------------
//
// Copyright (c) 1990-1995  Microsoft Corporation
//
// Module Name:
//
//    WinSpool.h
//
// Abstract:
//
//    Header file for Print APIs
//

#include <WINSPOOL.H>

extern BOOL        EnumPrinters(DWORD, LPSTR, DWORD, LPBYTE, DWORD, ;
                   LPDWORD, LPDWORD) winspool.drv ;
                   from "EnumPrintersA"
extern BOOL        OpenPrinter(LPSTR, LPHANDLE, LPPRINTER_DEFAULTS) winspool.drv ;
                   from "OpenPrinterA"
extern BOOL        ResetPrinter(HANDLE, LPPRINTER_DEFAULTS) winspool.drv ;
                      from "ResetPrinterA"
extern BOOL        SetJob(HANDLE, DWORD, DWORD, LPBYTE, DWORD) winspool.drv ;
                   from "SetJobA"
extern BOOL        GetJob(HANDLE, WORD, WORD, PBYTE, WORD, PDWORD) winspool.drv ;
                   from "GetJobA"
extern BOOL        EnumJobs(HANDLE, DWORD, DWORD, DWORD, LPBYTE, DWORD, ;
                   LPDWORD, LPDWORD) winspool.drv ;
                   from "EnumJobsA"
extern HANDLE      AddPrinter(LPSTR, DWORD, LPBYTE) winspool.drv ;
                   from "AddPrinterA"
extern BOOL        DeletePrinter( HANDLE ) winspool.drv
extern BOOL        SetPrinter(HANDLE, DWORD, LPBYTE, DWORD) winspool.drv ;
                   from "SetPrinterA"
extern BOOL        GetPrinter(HANDLE, DWORD, LPBYTE, DWORD, LPDWORD) winspool.drv ;
                   from "GetPrinterA"
extern BOOL        AddPrinterDriver(LPSTR, DWORD, LPBYTE) winspool.drv ;
                   from "AddPrinterDriverA"
extern BOOL        EnumPrinterDrivers(LPSTR, LPSTR, DWORD, LPBYTE, DWORD, ;
                   LPDWORD, LPDWORD) winspool.drv ;
                   from "EnumPrinterDriversA"
extern BOOL        GetPrinterDriver(HANDLE, LPSTR, DWORD, LPBYTE, DWORD, ;
                   LPDWORD) winspool.drv ;
                   from "GetPrinterDriverA"
extern BOOL        GetPrinterDriverDirectory(LPSTR, LPSTR, DWORD, LPBYTE, ;
                   DWORD, LPDWORD) winspool.drv ;
                   from "GetPrinterDriverDirectoryA"
extern BOOL        DeletePrinterDriver(LPSTR, PSTR, PSTR) winspool.drv ;
                   from "DeletePrinterDriverA"
extern BOOL        AddPrintProcessor(LPSTR, LPSTR, LPSTR, LPSTR) winspool.drv ;
                   from "AddPrintProcessorA"
extern BOOL        EnumPrintProcessors(LPSTR, LPSTR, DWORD, LPBYTE, DWORD, ;
                   LPDWORD, LPDWORD) winspool.drv ;
                   from "EnumPrintProcessorsA"
extern BOOL        GetPrintProcessorDirectory(LPSTR, LPSTR, DWORD, LPBYTE, ;
                   DWORD, LPDWORD) winspool.drv ;
                   from "GetPrintProcessorDirectoryA"
extern BOOL        EnumPrintProcessorDatatypes(LPSTR, LPSTR, DWORD, LPBYTE, ;
                   DWORD, LPDWORD, LPDWORD) winspool.drv ;
                   from "EnumPrintProcessorDatatypesA"
extern BOOL        DeletePrintProcessor(LPSTR, LPSTR, LPSTR) winspool.drv ;
                   from "DeletePrintProcessorA"
extern DWORD       StartDocPrinter(HANDLE, DWORD, LPBYTE) winspool.drv ;
                   from "StartDocPrinterA"
extern BOOL        StartPagePrinter(HANDLE) winspool.drv
extern BOOL        WritePrinter(HANDLE, LPVOID, DWORD, LPDWORD) winspool.drv
extern BOOL        EndPagePrinter(HANDLE) winspool.drv
extern BOOL        AbortPrinter(HANDLE) winspool.drv
extern BOOL        ReadPrinter(HANDLE, LPVOID, DWORD, LPDWORD) winspool.drv
extern BOOL        EndDocPrinter(HANDLE) winspool.drv
extern BOOL        AddJob(HANDLE, DWORD, LPBYTE, DWORD, LPDWORD) winspool.drv ;
                   from "AddJobA"
extern BOOL        ScheduleJob(HANDLE, DWORD) winspool.drv
extern BOOL        PrinterProperties(HWND, HANDLE) winspool.drv
extern LONG        DocumentProperties(HWND, HANDLE, LPSTR, PDEVMODEA, ;
                   PDEVMODEA, DWORD) winspool.drv ;
                   from "DocumentPropertiesA"
extern LONG        AdvancedDocumentProperties(HWND, HANDLE, LPSTR, ;
                   PDEVMODEA, PDEVMODEA) winspool.drv ;
                   from "AdvancedDocumentPropertiesA"
extern DWORD       GetPrinterData(HANDLE, LPSTR, LPDWORD, LPBYTE, DWORD, ;
                   LPDWORD) winspool.drv ;
                   from "GetPrinterDataA"
extern DWORD       SetPrinterData(HANDLE, LPSTR, DWORD, LPBYTE, ;
                   DWORD) winspool.drv ;
                   from "SetPrinterDataA"

                   extern DWORD       WaitForPrinterChange(HANDLE, DWORD) winspool.drv
extern HANDLE      FindFirstPrinterChangeNotification(HANDLE, DWORD, ;
                   DWORD, LPVOID) winspool.drv
extern BOOL        FindNextPrinterChangeNotification(HANDLE, PDWORD, ;
                   LPVOID, LPVOID) winspool.drv
extern BOOL        FreePrinterNotifyInfo(PPRINTER_NOTIFY_INFO) winspool.drv
extern BOOL        FindClosePrinterChangeNotification(HANDLE) winspool.drv
extern DWORD       PrinterMessageBox(HANDLE, DWORD, HWND, LPSTR, LPSTR, ;
                   DWORD) winspool.drv ;
                   from "PrinterMessageBoxA"

extern BOOL        ClosePrinter(HANDLE) winspool.drv

extern BOOL        AddForm(HANDLE, DWORD, LPBYTE) winspool.drv ;
                   from "AddFormA"
extern BOOL        DeleteForm(HANDLE, LPSTR) winspool.drv ;
                   from "DeleteFormA"
extern BOOL        GetForm(HANDLE, LPSTR, DWORD, LPBYTE, DWORD, ;
                   LPDWORD) winspool.drv ;
                   from "GetFormA"
extern BOOL        SetForm(HANDLE, LPSTR, DWORD, LPBYTE) winspool.drv ;
                   from "SetFormA"
extern BOOL        EnumForms(HANDLE, DWORD, LPBYTE, DWORD, LPDWORD, ;
                   LPDWORD) winspool.drv ;
                   from "EnumFormsA"

extern BOOL        EnumMonitors(LPSTR, DWORD, LPBYTE, DWORD, LPDWORD, ;
                   LPDWORD) winspool.drv ;
                   from "EnumMonitorsA"
extern BOOL        AddMonitor(LPSTR, DWORD, LPBYTE) winspool.drv ;
                   from "AddMonitorA"
extern BOOL        DeleteMonitor(LPSTR, LPSTR, LPSTR) winspool.drv ;
                   from "DeleteMonitorA"
extern BOOL        EnumPorts(LPSTR, DWORD, LPBYTE, DWORD, LPDWORD, ;
                   LPDWORD) winspool.drv ;
                   from "EnumPortsA"
extern BOOL        AddPort(LPSTR, HWND, LPSTR) winspool.drv ;
                   from "AddPortA"
extern BOOL        ConfigurePort(LPSTR, HWND, LPSTR) winspool.drv ;
                   from "ConfigurePortA"
extern BOOL        DeletePort(LPSTR, HWND, LPSTR) winspool.drv ;
                   from "DeletePortA"

extern BOOL        AddPrinterConnection(LPSTR) winspool.drv ;
                   from "AddPrinterConnectionA"

extern BOOL        DeletePrinterConnection(LPSTR) winspool.drv ;
                   from "DeletePrinterConnectionA"
extern HANDLE      ConnectToPrinterDlg(HWND, DWORD) winspool.drv
extern BOOL        AddPrintProvidor(LPSTR, DWORD, LPBYTE) winspool.drv ;
                   from "AddPrintProvidorA"
extern BOOL        DeletePrintProvidor(LPSTR, LPSTR, LPSTR) winspool.drv ;
                   from "DeletePrintProvidorA"


